
int gate1 = 11; // služe za okretanje motora u jednom, odnosno u drugom smjeru
int gate2 = 12; //odnosno za simulaciju otkljucavanja i zakljucavanja vrata
  

int broj_osoba = 0;   // broj osoba u kuci, unosi se tijekom personalizacije
int zakljucano=0;   // zastavica 1 za zakljucano, O za otkljucano. 
                    // pretpostavlja se da u trenutku inicijalizacije sustava netko 
                    //boravi u kući, pa su vrata otključana
int prolaz1 = 0;    // zastavica, 1 označava prolazak kroz zraku 1
int prolaz2 = 0;    // zastavica, 1 označava prolaz kroz zraku 2

unsigned long previousTime = 0;  //za vrijeme
byte seconds ;
byte minutes ;
byte hours ;

int pocetno_vrijeme =0;     //pocetak i kraj intervala kada zelimo da vratat budu zakljucana
int konacno_vrijeme =0;
int jedanput = 1;

const int NUMBER_OF_FIELDS = 11; // how many comma-separated fields we expect
int fieldIndex = 0;             // the current field being received
int values[NUMBER_OF_FIELDS];   // array holding values for all the fields

void setup() {
        Serial.begin(9600);     // opens serial port, sets data rate to 9600 bps
         pinMode(gate1, OUTPUT);
         pinMode(gate2, OUTPUT);
         digitalWrite(gate1, LOW);
         digitalWrite(gate2, LOW);
         Serial.print("Unesite inicijalne vrijednosti odvojene zarezom na slijedeći način: trenutni broj osoba u kući, 1 ako su vrata trenutno zaključana i 0 ako nisu, trenutno vrijeme-sati, trenutno vijeme-minute, trenutno vrijeme- sekunde, \n");
         Serial.print("vrijeme zakljucavanja - sati, minute, sekunde, vrijeme otkljucavanja - sati, minute, sekunde\n");
         
}

void loop() {

        // personalizacija
if(jedanput==1){    
        
  if( Serial.available()) {
    for(fieldIndex = 0; fieldIndex  < 11; fieldIndex ++)
    {
      values[fieldIndex] = Serial.parseInt(); // get a numeric value

    }
    Serial.print( fieldIndex);
    Serial.println(" fields received:");
    for(int i=0; i <  fieldIndex; i++)
    {
       Serial.println(values[i]);
    }
    fieldIndex = 0;  // ready to start over
    jedanput--;
  }
  
          broj_osoba = values[0];   // broj osoba u kuci, unosi se tijekom personalizacije
        zakljucano=values[1];
        previousTime=1000*(values[4] + 60*values[3] + 3600*values[2]);
        pocetno_vrijeme=1000*(values[7] + 60*values[6] + 3600*values[5]);
        konacno_vrijeme=1000*(values[10] + 60*values[9] + 3600*values[8]);
        
}
if(jedanput == 0){ 

    // detekcija jesu se vrata otkučala/zaključala RUČNO
         int kanal1 = analogRead(A0);
         int kanal2 = analogRead(A1);
         int zakljucavanje=0;
         zakljucavanje= kanal1 - kanal2;
         if(zakljucavanje > 30 || zakljucavanje < -30){
           if(zakljucano == 0){
             zakljucano=1;
             }
            if(zakljucano == 1){
               zakljucano=0;
               }
         } 
         //Serial.println(zakljucavanje);
         delay(10);        // delay in between reads for stability
         
    //detekcija prolaska kroz prvu zraku
        int zraka1 = analogRead(A2);
        //Serial.println(zraka1);
        delay(10);
        if(zraka1 < 600){
          prolaz1=1;
        }
    
    //detekcija prolaska kroz drugu zraku
        int zraka2 = analogRead(A3);
        //Serial.println(zraka2);
        delay(10);
        if(zraka2 < 700){
          prolaz2=1;
        }
        
    //brojanje osoba
        if(prolaz1 == 1 && prolaz2 == 0){
          Serial.print("osoba usla \n");
          broj_osoba ++;
          delay(500);
          prolaz1 = 0;
          
        }
        if(prolaz1 == 0 && prolaz2 == 1){
          Serial.print("osoba izasla \n");
          broj_osoba --;
          delay(500);
          prolaz2 = 0;
        }
     
    //ukoliko je ostalo nula osoba u kući, a vrata ostala otkljucana, zakljucaj ih nakon x vremena
        if(broj_osoba == 0 && zakljucano == 0){
          delay(5000);                   //cekanje
         //  Serial.print(zakljucano);
         //  Serial.print("\n");  
         // Serial.print("zakljucavanje\n"); 
         // Serial.print(zakljucavanje); 
         // Serial.print("\n");
          
           Serial.print("zakljucavanje \n");
           digitalWrite(gate1, HIGH);     // zakljucavanje...
           delay(30);
           //analogWrite(gate1, 0);
           digitalWrite(gate1, LOW);
           delay(1000);
           zakljucano = 1;
        }
        
    //mjerenje vremena

    if (millis() >= (previousTime)  ) {
    previousTime = previousTime + 1000;  // use 100000 for uS
    seconds = seconds +1;
    if (seconds == 60)
    {
    seconds = 0;
    minutes = minutes +1;
    }
    if (minutes == 60)
    {
    minutes = 0;
    hours = hours +1;
    }
    if (hours == 24)
    {
    hours = 0;
    }
    Serial.print (hours, DEC);
    Serial.print (":");
    Serial.print (minutes,DEC);
    Serial.print (":");
    Serial.println(seconds,DEC);   
    }
    
    //zakljucavanje, odonosno otkljucavanje u zeljenom trenutku dana
    if(previousTime == pocetno_vrijeme){
           digitalWrite(gate1, HIGH);     // zakljucavanje...
           delay(30);
           //analogWrite(gate1, 0);
           digitalWrite(gate1, LOW);
           delay(1000);
     }

     if(previousTime == konacno_vrijeme){
           digitalWrite(gate2, HIGH);     // otkljucavanje...
           delay(30);
           
           digitalWrite(gate2, LOW);
           delay(1000);
     }      
   
    
  }
  
}
 

